/* Problem URL: https://codeforces.com/problemset/problem/1817/B */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, m;
    cin >> n >> m;

    vvi graph(n);
    while (m--) {
        int a, b;
        cin >> a >> b;
        a--, b--;

        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    V<bool> vis(n);

    function<bool(int, int, int)> find = [&](int i, int t, int p) {
        vis[i] = true;

        repv(j, graph[i]) {
            if (j == p) {
                continue;
            }

            if (j == t) {
                return true;
            }

            if (vis[j]) {
                continue;
            }

            if (find(j, t, i)) {
                return true;
            }
        }

        return false;
    };

    rep(i, n) {
        if (graph[i].size() < 4) {
            continue;
        }

        fill(all(vis), false);

        if (!find(i, i, i)) {
            continue;
        }

        V<pair<int, int>> ans;
        V<bool> loop(n);

        function<pair<int, int>()> get = [&]() -> pair<int, int> {
            rep(l1, graph[i].size() - 1) {
                nrep(l2, l1 + 1, graph[i].size()) {
                    fill(all(vis), false);
                    int one = graph[i][l1];
                    int two = graph[i][l2];
                    function<bool(int, int)> test = [&](int j, int p) {
                        vis[j] = true;
                        repv(k, graph[j]) {
                            if (k == one || k == two) {
                                continue;
                            }

                            if (k == p) {
                                continue;
                            }

                            if (k == i) {
                                loop[j] = true;
                                return true;
                            }

                            if (vis[k]) {
                                continue;
                            }

                            if (test(k, j)) {
                                loop[j] = true;
                                return true;
                            }
                        }

                        return false;
                    };

                    if (test(i, i)) {
                        return {one, two};
                    }
                }
            }

            return {-1, -1};
        };

        auto [one, two] = get();

        ans.emplace_back(i + 1, one + 1);
        ans.emplace_back(i + 1, two + 1);

        fill(all(vis), false);
        int now = -1;
        int p = -1;
        int next = i;
        while (next != -1) {
            now = next;
            vis[now] = true;
            next = -1;
            repv(j, graph[now]) {
                if (j == p || !loop[j]) {
                    continue;
                }

                if (j == i) {
                    ans.emplace_back(i + 1, now + 1);
                    break;
                }

                if (vis[j]) {
                    continue;
                }

                p = now;
                next = j;
                ans.emplace_back(now + 1, j + 1);
                break;
            }
        }

        cout << "YES\n";
        cout << ans.size() << '\n';
        repv(i, ans) {
            cout << i.first << ' ' << i.second << '\n';
        }
        return;
    }

    cout << "NO\n";
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
